﻿
Public Class main



    Private Structure SYSTEM_POWER_STATUS
        Dim ACLineStatus As Byte
        Dim BatteryFlag As Byte
        Dim BatteryLifePercent As Byte
        Dim Reserved1 As Byte
        Dim BatteryLifeTime As Integer
        Dim BatteryFullLifeTime As Integer
    End Structure

    Private Declare Function GetSystemPowerStatus Lib "kernel32" Alias "GetSystemPowerStatus" (ByRef lpSystemPowerStatus As SYSTEM_POWER_STATUS) As Integer
    Dim sStatus As SYSTEM_POWER_STATUS

    Private Sub time()
        Dim t As TimeSpan = TimeSpan.FromSeconds(SystemInformation.PowerStatus.BatteryLifeRemaining)
        Label3.Text = t.ToString
        NAToolStripMenuItem.Text = t.ToString
        status.Label2.Text = t.ToString
        NotifyIcon1.BalloonTipText = t.ToString
        NotifyIcon1.Text = t.ToString




    End Sub


    Private Sub Energiestatus()
        Dim power As PowerStatus = SystemInformation.PowerStatus
        MetroProgressbar1.Value = power.BatteryLifePercent * 100
        NAToolStripMenuItem1.Text = power.BatteryLifePercent * 100 & "%"
        NotifyIcon1.BalloonTipTitle = power.BatteryLifePercent * 100 & "% Verbleibend"

        status.Label1.Text = power.BatteryLifePercent * 100 & "%"

        Label2.Text = power.BatteryLifePercent * 100 & "%"
        If power.PowerLineStatus = PowerLineStatus.Online And (power.BatteryLifePercent * 100) < 100 Then
            Label1.Text = "Wird geladen"
        ElseIf power.PowerLineStatus = PowerLineStatus.Online Then
            Label1.Text = "Netzbetrieb"
        ElseIf power.PowerLineStatus = PowerLineStatus.Offline Then
            Label1.Text = "Akkubetrieb"
        End If
    End Sub
    Dim mouseOffset As Point

    'macht das fenster bewegbar
    Private Sub Me_MouseDown(ByVal sender As Object, _
        ByVal e As MouseEventArgs) _
        Handles MyBase.MouseDown
        mouseOffset = New Point(-e.X, -e.Y)
    End Sub
    Private Sub Me_MouseMove(ByVal sender As Object, _
        ByVal e As MouseEventArgs) _
        Handles MyBase.MouseMove

        If e.Button = MouseButtons.Left Then
            Dim mousePos As Point = Control.MousePosition
            mousePos.Offset(mouseOffset.X, mouseOffset.Y)
            Location = mousePos
        End If
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load







    'lade alle wichtigen daten (ladezustand etc.)
        time()
        Energiestatus()
        GetSystemPowerStatus(sStatus)
        battery_picture()


        status.Show()
        status.Visible = False


    'startverhalten des programms

        If My.Settings.start = "gadget" Then
            Me.WindowState = FormWindowState.Minimized
            status.Show()
            status.Visible = True
        End If

        If My.Settings.start = "normal" Then
            status.Visible = False
        End If

        If My.Settings.start = "info" Then
            status.Visible = False
            Me.WindowState = FormWindowState.Minimized
        End If


    'intervall für notify benachrichtigungen

        Timer3.Interval = My.Settings.interval
        If My.Settings.notify = "true" Then
            Timer3.Enabled = True
        Else
            Timer3.Enabled = False
        End If



    End Sub



    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        GetSystemPowerStatus(sStatus)

      

        'energiestatus aktualisieren
        Energiestatus()

        'einstellungen aktualisieren
        If My.Settings.gadgettopmost = "true" Then
            status.TopMost = True
        Else
            status.TopMost = False


        End If
    End Sub

    Private Sub battery_picture()

        'akku symbol &; labelfarbe setzen
        If MetroProgressbar1.Value <= 20 AndAlso MetroProgressbar1.Value >= 0 Then
            PictureBox3.BackgroundImage = My.Resources._20_0
            Label2.ForeColor = Color.Red
        End If

        If MetroProgressbar1.Value <= 30 AndAlso MetroProgressbar1.Value >= 20 Then
            PictureBox3.BackgroundImage = My.Resources._30_20
            Label2.ForeColor = Color.Red
        End If


        If MetroProgressbar1.Value <= 40 AndAlso MetroProgressbar1.Value >= 30 Then
            PictureBox3.BackgroundImage = My.Resources._40_30
            Label2.ForeColor = Color.Red

        End If
        If MetroProgressbar1.Value <= 60 AndAlso MetroProgressbar1.Value >= 40 Then
            PictureBox3.BackgroundImage = My.Resources._60_40
            Label2.ForeColor = Color.White
        End If
        If MetroProgressbar1.Value <= 80 AndAlso MetroProgressbar1.Value >= 60 Then
            PictureBox3.BackgroundImage = My.Resources._80_60
            Label2.ForeColor = Color.White
        End If
        If MetroProgressbar1.Value <= 100 AndAlso MetroProgressbar1.Value >= 80 Then
            PictureBox3.BackgroundImage = My.Resources._100_80
            Label2.ForeColor = Color.White
        End If

    End Sub

    Private Sub Timer2_Tick(sender As Object, e As EventArgs) Handles Timer2.Tick
        time()
        battery_picture()

        If My.Settings.warnung = "true" Then
            If MetroProgressbar1.Value <= My.Settings.warnungvalue Then
                achtung.Show()

            End If
            If My.Settings.warnung = "wait" Then
                If MetroProgressbar1.Value = 100 Then
                    My.Settings.warnung = True
                End If
            End If

        End If






    End Sub

    Private Sub BeendenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles BeendenToolStripMenuItem.Click


        Me.Close()
    End Sub


    Private Sub NotifyIcon1_MouseDoubleClick(sender As Object, e As MouseEventArgs) Handles NotifyIcon1.MouseDoubleClick
        Me.Show()
    End Sub

    Private Sub PictureBox1_Click(sender As Object, e As EventArgs) Handles PictureBox1.Click
        If My.Settings.close = "true" Then

            Me.Close()
        Else
            Me.WindowState = FormWindowState.Minimized
        End If


    End Sub

    Private Sub Timer3_Tick(sender As Object, e As EventArgs) Handles Timer3.Tick
        NotifyIcon1.ShowBalloonTip(10)
    End Sub

    Private Sub PictureBox2_Click(sender As Object, e As EventArgs) Handles PictureBox2.Click
        info.Show()
    End Sub

    Private Sub ToolStripMenuItem1_Click(sender As Object, e As EventArgs) Handles ToolStripMenuItem1.Click
        settings.Show()
    End Sub

    Private Sub PictureBox4_Click(sender As Object, e As EventArgs) Handles PictureBox4.Click
        settings.Show()
    End Sub

    Private Sub PictureBox5_Click(sender As Object, e As EventArgs) Handles PictureBox5.Click
        status.Visible = True
        status.Show()
    End Sub


End Class
